// WaveVueDoc.cpp : implementation of the CWaveVueDoc class
//

#include "stdafx.h"
#include "WaveVue.h"

#include "WaveVueDoc.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWaveVueDoc

IMPLEMENT_DYNCREATE(CWaveVueDoc, CDocument)

BEGIN_MESSAGE_MAP(CWaveVueDoc, CDocument)
	//{{AFX_MSG_MAP(CWaveVueDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWaveVueDoc construction/destruction

CWaveVueDoc::CWaveVueDoc()
{
	m_NumFFTPts = FFTSIZE/2;
}

CWaveVueDoc::~CWaveVueDoc()
{
}

BOOL CWaveVueDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	m_WaveFileOpen = FALSE;
	m_FFTOffset = 0;
	if(!ReadFromRegistry())		// if registry read fails, load defaults
	{
		m_SrcFilePath = _T("");
		m_DestFilePath = _T("");
	}
	for( INT i=0; i<256; i++)
	{
		if( (i<43) )
			m_ColorTbl[i] = RGB( 0,0, 255*(i)/43);
		if( (i>=43) && (i<87) )
			m_ColorTbl[i] = RGB( 0, 255*(i-43)/43, 255 );
		if( (i>=87) && (i<120) )
			m_ColorTbl[i] = RGB( 0,255, 255-(255*(i-87)/32));
		if( (i>=120) && (i<154) )
			m_ColorTbl[i] = RGB( (255*(i-120)/33), 255, 0);
		if( (i>=154) && (i<217) )
			m_ColorTbl[i] = RGB( 255, 255 - (255*(i-154)/62), 0);
		if( (i>=217)  )
			m_ColorTbl[i] = RGB( 255, 0, 128*(i-217)/38);
	}
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CWaveVueDoc serialization

void CWaveVueDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CWaveVueDoc diagnostics

#ifdef _DEBUG
void CWaveVueDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CWaveVueDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWaveVueDoc commands

void CWaveVueDoc::OnCloseDocument() 
{
	WriteToRegistry();
	CDocument::OnCloseDocument();
}

BOOL CWaveVueDoc::WriteToRegistry()
{
BOOL bSpare = FALSE;
INT iSpare = 0;
double dSpare = 0.0;
CWinApp* pApp = AfxGetApp();
CString str;
//save BOOL's
	str.Format("%i:%i:%i:%i:%i:%i:%i:%i:",
		bSpare,
		bSpare,
		bSpare,
		bSpare,
		bSpare,
		bSpare,
		bSpare,
		bSpare);
	if(!pApp->WriteProfileString("Settings\\BOOLs", "BOOLs", str))
		return FALSE;
//save INT's
	str.Format("%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:",
		m_FFTOffset,
		iSpare,
		iSpare,
		iSpare,
		iSpare,
		iSpare,
		iSpare,
		iSpare,
		iSpare,
		iSpare);
	if(!pApp->WriteProfileString("Settings\\INTs", "INTs", str))
		return FALSE;

//save doubles's
	str.Format("%lg:%lg:%lg:%lg:%lg:%lg:%lg:%lg:%lg:%lg:%lg:",
		dSpare,
		dSpare,
		dSpare,
		dSpare,
		dSpare,
		dSpare,
		dSpare,
		dSpare,
		dSpare,
		dSpare,
		dSpare);
	if(!pApp->WriteProfileString("Settings\\DOUBLEs", "DOUBLEs", str))
		return FALSE;

//save strings
	if(!pApp->WriteProfileString("Settings\\Strings", "SrcPath", m_SrcFilePath))
		return FALSE;
	if(!pApp->WriteProfileString("Settings\\Strings", "DestPath", m_DestFilePath))
		return FALSE;
	return TRUE;
}

BOOL CWaveVueDoc::ReadFromRegistry()
{
BOOL bSpare = FALSE;
INT iSpare = 0;
double dSpare = 0.0;
CWinApp* pApp = AfxGetApp();
CString str;
INT cRead;
	str = pApp->GetProfileString ("Settings\\BOOLs", "BOOLs");
	if(str.IsEmpty ())
		return FALSE;
// Get BOOLs
	cRead = _stscanf (str, "%i:%i:%i:%i:%i:%i:%i:%i:",
		&bSpare,
		&bSpare,
		&bSpare,
		&bSpare,
		&bSpare,
		&bSpare,
		&bSpare,
		&bSpare);
	if(cRead != 8)
		return FALSE;
//Get INT's
	str = pApp->GetProfileString ("Settings\\INTs", "INTs");
	if(str.IsEmpty ())
		return FALSE;
	cRead = _stscanf(str, "%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:",
		&m_FFTOffset,
		&iSpare,
		&iSpare,
		&iSpare,
		&iSpare,
		&iSpare,
		&iSpare,
		&iSpare,
		&iSpare,
		&iSpare);
	if(cRead != 10)
		return FALSE;
//get doubles's
	str = pApp->GetProfileString("Settings\\DOUBLEs", "DOUBLEs");
	if(str.IsEmpty ())
		return FALSE;
	cRead = _stscanf(str, "%lg:%lg:%lg:%lg:%lg:%lg:%lg:%lg:%lg:%lg:%lg:",
		&dSpare,
		&dSpare,
		&dSpare,
		&dSpare,
		&dSpare,
		&dSpare,
		&dSpare,
		&dSpare,
		&dSpare,
		&dSpare,
		&dSpare);
	if(cRead != 11)
		return FALSE;
//get strings
	m_SrcFilePath = pApp->GetProfileString("Settings\\Strings", "SrcPath",_T("c:\\"));
	m_DestFilePath = pApp->GetProfileString("Settings\\Strings", "DestPath",_T("c:\\"));
	return TRUE;
}

UINT CWaveVueDoc::GetDiskSpace()
{
char drive;
CWave tWave;
	// Fill disk free information
	drive = _getdrive()-1 + _T('A');
	CString sDrive = drive;
	sDrive = sDrive + ":\\"; // use current default drive
	LONGLONG size = tWave.GetDriveFreeSpace( &sDrive);
	size /= 1000000;
	return (UINT)size;	
}


BOOL CWaveVueDoc::GetFileParameters(CString path)
{
INT ErrorCode;
DWORD FileLength;
DWORD FileSource;
CWave TWave;
#if 0	//fix screwed up data chunks
static FILE *stream = NULL;
	stream = fopen( (LPCTSTR)path, "r+b" );	//Open file for write
	if( stream)
	{
		char buf[8];
		fseek(stream,0x26,SEEK_SET);
		fread( buf, sizeof( char ), 4, stream );
		//if is a spectraBlue file with auxi field
		if( (buf[0]=='a') &&(buf[1]=='u') &&(buf[2]=='x') &&(buf[3]=='i') )
		{
			fseek(stream,0,SEEK_END);	//find end of file
			__int64 length;
			fgetpos( stream, &length);
			length -= 0x80L;
			fseek(stream,0x72,SEEK_SET);
			fread( buf, sizeof( char ), 4, stream );
			if( (buf[0]!='d') ||(buf[1]!='a') ||(buf[2]!='t') ||(buf[3]!='a') )
			{
				buf[0]='d';buf[1]='a';buf[2]='t';buf[3]='a';
				buf[4] = (char)(length&0x0FF);
				buf[5] = (char)((length>>8)&0x0FF);
				buf[6] = (char)((length>>16)&0x0FF);
				buf[7] = (char)((length>>24)&0x0FF);
				fseek(stream,0x72,SEEK_SET);
				fwrite( buf, sizeof( char ), 8, stream );
			}
		}
		fclose(stream);
	}
#endif
	
	ErrorCode = TWave.InOpen( &path, &m_Wfx, 0, &FileLength, 0, &m_AuxInfo, &FileSource);
	if( !ErrorCode )
	{
		if( m_Wfx.nChannels != 1)
		{
			m_Complex = TRUE;
			m_NumFFTPts = FFTSIZE;
		}
		else
		{
			m_Complex = FALSE;
			m_NumFFTPts = FFTSIZE/2;
		}
		m_StartTime = m_AuxInfo.StartTime;
		m_EndTime = m_AuxInfo.StopTime;
		m_TotalSeconds = TWave.GetInTotalSecs();
		return TRUE;
	}
	else
	{
		m_TotalSeconds = 0;
		return FALSE;
	}
}

BOOL CWaveVueDoc::OpenWaveFile(CString Path)
{
INT ErrorCode;
DWORD FileSource = 0;
	m_FileLength = 0;
	memset( &m_AuxInfo, 0, sizeof(m_AuxInfo) );
	m_Wave.InClose();

	ErrorCode = m_Wave.InOpen( &Path, &m_Wfx, FFTSIZE, &m_FileLength, 0, &m_AuxInfo, &FileSource );
	if( !ErrorCode )
	{
		if( m_Wfx.nChannels != 1)
		{
			m_Complex = TRUE;
			m_NumFFTPts = FFTSIZE;
		}
		else
		{
			m_Complex = FALSE;
			m_NumFFTPts = FFTSIZE/2;
		}
		m_StartTime = m_AuxInfo.StartTime;
		m_EndTime = m_AuxInfo.StopTime;
		m_TotalSeconds = m_Wave.GetInTotalSecs();
		return TRUE;
	}
	else
	{
		m_TotalSeconds = 0;
		return FALSE;
	}
}

void CWaveVueDoc::CloseWaveFile()
{
	m_Wave.InClose();
	m_WaveFileOpen = FALSE;
}

